#include <stdio.h>
void quickSort(int arr[], int low, int high);
int getIndex(int arr[], int low, int high);
void quickSort(int arr[], int low, int high) {
    if (low < high) {
        int index = getIndex(arr, low, high); // 找寻基准数据的正确索引
        quickSort(arr, low, index - 1); // 对左半段排序
        quickSort(arr, index + 1, high); // 对右半段排序
    }
}
int getIndex(int arr[], int low, int high) {
    int pivot = arr[low]; // 基准数据
    int mark = low + 1; // mark 指针，从基准的下一个位置开始
    for (int i = mark; i <= high; i++) {
        if (arr[i] < pivot) { // 如果当前元素小于基准元素
            // 交换 arr[i] 和 arr[mark] 的值
            int temp = arr[i];
            arr[i] = arr[mark];
            arr[mark] = temp;
            mark++; // mark 指针右移
        }
    }
    // 最后将基准元素放到正确的位置
    arr[low] = arr[mark - 1];
    arr[mark - 1] = pivot;
    return mark - 1; // 返回基准数据的索引
}

int main() {
    int arr[] = {3, 5, 2, 6, 1, 4,-1,9,0};
    int n = sizeof(arr) / sizeof(arr[0]);
    quickSort(arr, 0, n - 1);    

    printf("排序后: ");
    for (int i = 0; i < n; i++)   
         printf("%d ", arr[i]);  
    printf("\n");
    return 0;
}
